import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { de_DeletePipelineCommand, se_DeletePipelineCommand } from "../protocols/Aws_json1_1";
export { $Command };
export class DeletePipelineCommand extends $Command
    .classBuilder()
    .ep(commonParams)
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("CodePipeline_20150709", "DeletePipeline", {})
    .n("CodePipelineClient", "DeletePipelineCommand")
    .f(void 0, void 0)
    .ser(se_DeletePipelineCommand)
    .de(de_DeletePipelineCommand)
    .build() {
}
