import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { de_GetPipelineExecutionCommand, se_GetPipelineExecutionCommand } from "../protocols/Aws_json1_1";
export { $Command };
export class GetPipelineExecutionCommand extends $Command
    .classBuilder()
    .ep(commonParams)
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("CodePipeline_20150709", "GetPipelineExecution", {})
    .n("CodePipelineClient", "GetPipelineExecutionCommand")
    .f(void 0, void 0)
    .ser(se_GetPipelineExecutionCommand)
    .de(de_GetPipelineExecutionCommand)
    .build() {
}
