import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { PollForJobsOutputFilterSensitiveLog } from "../models/models_0";
import { de_PollForJobsCommand, se_PollForJobsCommand } from "../protocols/Aws_json1_1";
export { $Command };
export class PollForJobsCommand extends $Command
    .classBuilder()
    .ep(commonParams)
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("CodePipeline_20150709", "PollForJobs", {})
    .n("CodePipelineClient", "PollForJobsCommand")
    .f(void 0, PollForJobsOutputFilterSensitiveLog)
    .ser(se_PollForJobsCommand)
    .de(de_PollForJobsCommand)
    .build() {
}
